#!/usr/bin/python3

import trio
import ksptrio

klienti = []

async def posli_zpravu(spojeni, zprava):
    await spojeni.send_all((zprava + '\n').encode('utf-8'))

async def posli_vsem(zprava):
    for spojeni in klienti:
        await posli_zpravu(spojeni, zprava)

async def obsluz_spojeni(spojeni):
    # Odešli historii zpráv
    klienti.append(spojeni)
    try:
        radky = ksptrio.LineReader(spojeni)
        while True:
            text = await radky.readline()
            await posli_vsem(text)
    finally:
        klienti.remove(spojeni)


async def main():
    await trio.serve_tcp(obsluz_spojeni, 1234)

trio.run(main)



