#!/usr/bin/python3

import trio
import ksptrio

historie = []
klienti = []
jmena = []

async def posli_zpravu(spojeni, zprava):
    await spojeni.send_all((zprava + '\n').encode('utf-8'))

async def posli_vsem(zprava):
    for spojeni in klienti:
        await posli_zpravu(spojeni, zprava)

async def obsluz_spojeni(spojeni):
    # Odešli historii zpráv
    klienti.append(spojeni)
    try:
        for zprava in historie:
            await posli_zpravu(spojeni, zprava)
        await posli_zpravu(spojeni, "Zadej jmeno:")
        radky = ksptrio.LineReader(spojeni)
        jmeno = await radky.readline()
        if not jmeno: return
        await posli_vsem(f'Uzivatel {jmeno} se pripojil')
        while True:
            text = await radky.readline()
            if not text: break
            zprava = f'{jmeno}: {text}'
            await posli_vsem(zprava)
            historie.append(zprava) # přidej do historie
    finally:
        await posli_vsem(f'Uzivatel {jmeno} se odpojil')
        klienti.remove(spojeni)


async def main():
    await trio.serve_tcp(obsluz_spojeni, 1234)

trio.run(main)


