import trio
import httpx

pocet_radku = 0
pocet_vyskytu = 0

async def najdi_text(klient, scope, misto, url, text, vyskyty, max_vyskyty=10):
    global pocet_vyskytu, pocet_radku
    print("Procházím", url)
    async with klient.stream('GET', url) as response:
        print("Dostal jsem kód", response.status_code)
        if response.status_code != 200:
            return

        async for line in response.aiter_lines():
            if pocet_vyskytu >= max_vyskyty:
                print("Máme dost výskytů, končíme!")
                scope.cancel()
                break
            if text in line:
                vyskyty.append((misto, line))
                print("Text nalezen v", misto)
                pocet_vyskytu += 1
            pocet_radku += 1

def ksp_mista(min_rocnik, max_rocnik):
    ksp_prefix = "https://ksp.mff.cuni.cz/h/ulohy/"
    for rocnik in range(min_rocnik, max_rocnik+1):
        for serie in range(1, 6):
            for typ in ['zadani', 'reseni']:
                misto = typ + "-" + str(rocnik) + "-" + str(serie)
                url = ksp_prefix + str(rocnik) + "/" + typ + str(serie) + ".html"
                yield misto, url


async def projdi_ksp(min_rocnik, max_rocnik, text, max_vyskyty=5):
    global pocet_vyskytu, pocet_radku
    pocet_radku = 0
    pocet_vyskytu = 0
    vyskyty = []
    async with httpx.AsyncClient() as klient, trio.open_nursery() as nursery:
            for misto, url in ksp_mista(min_rocnik, max_rocnik):
                if pocet_vyskytu >= max_vyskyty:
                    nursery.cancel_scope.cancel()
                    break
                nursery.start_soon(najdi_text, klient, nursery.cancel_scope, misto, url, text, vyskyty, max_vyskyty)

    print("Celkem jsem prošel řádků:", pocet_radku)
    return vyskyty
