#!/usr/bin/python3

import trio
import ksptrio
import time
import sys


async def main():
    kumulativni = 0
    while True:
        await ksptrio.trio_input() # počkat na enter
        start = time.time()
        print("Startuji...")
        async with trio.open_nursery() as nursery:
            async def aktualizuj():
                while True:
                    ted = time.time()
                    mezicas = ted - start
                    celkem = kumulativni + mezicas
                    print(f'\r{celkem:.1f}', end='')
                    sys.stdout.flush()
                    await trio.sleep(0.1)
            async def pockej_na_konec():
                await ksptrio.trio_input()
                nursery.cancel_scope.cancel()
            nursery.start_soon(aktualizuj)
            nursery.start_soon(pockej_na_konec)
        konec = time.time()
        kumulativni += (konec - start)


trio.run(main)

